﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	public class CandidateFileGenerator : CandidatesGenerator
	{
		string file;
		public CandidateFileGenerator(string file)
		{
			this.file = file;
		}

		protected override ThreadSafeQueue<Community> generate(ThreadSafeQueue<Community> queue)
		{
			StreamReader reader = new StreamReader(file);
			string line;
			while(null != (line = reader.ReadLine()))
			{
				line = line.Trim();
				if (line == "" || line[0] == '#')
					continue;
				string[] parts = line.Split(' ');
				Community c = new Community(graph);
				foreach (string s in parts)
				{
					c.AddVertice(int.Parse(s));
				}
				queue.Enqueue(c);
			}
			return queue;
		}

		public override string abbr()
		{
			return "cfg";
		}
	}
}
