﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class EMClassifier : Classifier
	{
		double[] probIn,probOut;

		public EMClassifier(double[] probIn,double[] probOut)
		{
			this.probIn = probIn;
			this.probOut = probOut;
		}

		public override bool classify(BitArray values, int row)
		{
			double pIn = 1;
			double pOut = 1;

			for (int a = 0; a < values.N; a++)
			{
				if (values.get(a))
				{
					pIn *= probIn[a];
					pOut *= probOut[a];
				}
				else
				{
					pIn *= 1 - probIn[a];
					pOut *= 1 - probOut[a];
				}

				double minimum = Math.Pow(10, -10);
				if (pIn < minimum || pOut < minimum)
				{
					pIn *= Math.Pow(10.0,10);
					pOut *= Math.Pow(10.0, 10);
				}
				//Console.WriteLine(pIn + " " + pOut);
			}

			//Console.WriteLine(pIn + " " + pOut);
			return pIn < pOut;
		}
	}
}
