﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	public class FPNode
	{
		//just to debug easier give a unique number to each FPNode
		static int idCounter = 0;
		public int id;

		//item number
		public int item;
		public int freq;

		//FPTree structure
		public FPNode parent;
		public List<FPNode> children;
		public FPNode link;

		public FPNode()
		{
			children = new List<FPNode>();
			id = idCounter++;
		}

		public void AddChild(FPNode node)
		{
			children.Add(node);
		}

		/**
		 * Find a child with a specific item number or return null if it does not exists
		 */
		public FPNode getChild(int item)
		{
			foreach (FPNode c in children)
			{
				if (c.item == item)
					return c;
			}
			return null;
		}

		//print recursive in a readable way
		public void print(int d, TextWriter writer)
		{
			writer.WriteLine(new String(' ', d * 2)+"id: "+id+", item: "+item+", freq: "+freq+", link: "+(link==null?"null":""+link.id));
			foreach (FPNode c in children)
			{
				c.print(d + 1, writer);
			}
		}

	}
}
