﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	public class PatternNode
	{
		public PatternNode left, right, parent;
		public Pattern pattern;
		public bool classlabel;

		public bool classify(BitArray values)
		{
			if (pattern == null && left == null)
				return classlabel;
			if (pattern == null)
				return false;
			foreach (int i in pattern.items)
			{
				if (!values.get(i))
					return left.classify(values);
			}
			return right.classify(values);
		}

		public void print(int d, TextWriter writer)
		{
			string line = new String(' ', d * 2);
			if (left == null && right == null)
			{
				line += "leaf node, class: " + classlabel;
			}
			else
			{
				line += "internal node, pattern: {" + pattern + "}";
			}
			writer.WriteLine(line);
			if(left != null)
				left.print(d + 2, writer);
			if (right != null)
				left.print(d + 2, writer);
		}
	}
}
