﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	class FicReader : FileTypeReader<HashSet<Community>>
	{
		UndirectedGraph graph;

		public FicReader(string file, UndirectedGraph graph) : base(file)
		{
			this.graph = graph;
		}

		public override void readLine(String line, HashSet<Community> obj, int count)
		{
			if (line.Equals(""))
				return;
			line = line.Substring(0, line.IndexOf(':') - 1).Trim();
			string[] words = line.Split(' ');
			Community c = new Community(graph);
			foreach (string w in words)
			{
				c.AddVertice(int.Parse(w));
			}
			obj.Add(c);
		}

		public override HashSet<Community> createEmptyObject()
		{
			HashSet<Community> set = new HashSet<Community>(new CommunityEqualityComparer());
			return set;
		}
	}
}
