﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class Operation : IComparable<Operation>
	{
		public bool add;
		public double gain;
		public int v;
		public static bool addWithoutGain = true;

		public Operation(int v, double gain, bool add)
		{
			this.v = v;
			this.gain = gain;
			this.add = add;
		}

		public int CompareTo(Operation o)
		{
			if (gain > o.gain)
				return 1;
			else if (gain < o.gain)
				return -1;
			if (add && !o.add)
				return 1;
			if (!add && o.add)
				return -1;
			return 0;
		}

		public bool isImprovement()
		{
			return gain > 0 || (gain == 0 && add && addWithoutGain);
		}

		override public string ToString()
		{
			if (add)
				return "Add: " + v + ", dCG:" + gain + ", improves: " + (isImprovement() ? "Yes" : "No");
			else
				return "Remove: " + v + ", dCG:" + gain + ", improves: " + (isImprovement() ? "Yes" : "No");
		}
	}
}
