﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	public class PrintSteps : ExpProgram
	{
		//candidates
		CandidatesGenerator generator;

		public override void loadArguments(string[] args)
		{
			this.generator = new CandidateFileGenerator(datadir+args[0]);
		}

		public override void start()
		{
			ThreadSafeQueue<Community> candidates = generator.generate(graph, null);
			log("Numbers: ");
			log("Graph: |V|= " + graph.Count + ", |E|=" + graph.NumEdges);
			log("Candidates: " + candidates.Count);
			Directory.CreateDirectory(expdir + expName);
			StreamWriter writer = new StreamWriter(expdir + expName + "/results.csv");
			writer.WriteLine("id;Start community;End community;Size;CG(C);ICD(C);Steps");
			Console.WriteLine("Processing communities");
			string s = " ; ";
			int counter = 0;
			while (!candidates.Empty())
			{
				StreamWriter cwriter = new StreamWriter(expdir + expName + "/community_" + counter + ".csv");
				TimeMeasure m = new TimeMeasure();
				cwriter.WriteLine("Step ; Size(C) ; #E(C); CG(C) ; ICD(C); Vertices; Duration");
				int step = 0;
				Community c = candidates.Dequeue();
				List<int> list = new List<int>(c.getVertices().Keys);
				list.Sort();
				writer.Write(counter+s+Tools.listToString(list) + s);
				while (step == 0 || c.improve())
				{
					int e = 0;
					foreach (int i in c.getVertices().Values)
					{
						e += i;
					}
					cwriter.WriteLine(step + s + c.Size + s + e / 2 + s + c.communityGain() + s + c.intraClusterDensity() + s + Tools.listToString(new List<int>(c.getVertices().Keys))+s+m);
					step++;
				}
				list = new List<int>(c.getVertices().Keys);
				list.Sort();
				writer.WriteLine(Tools.listToString(list) + s + c.Size + s + c.communityGain() + s +c.intraClusterDensity()+s+ step);
				cwriter.Close();
				counter++;
			}
			writer.WriteLine();
			writer.Close();

		}
	}
}
